#include "stdafx.h"
#include "BMLBulletML.h"

namespace bml{



BMLStaticData gBMLData;


simple_array_type BMLStaticData::bullets;
	
action_array_type BMLStaticData::action_list;

al_free_queue BMLStaticData::fq;

al_push_queue BMLStaticData::pq;

smartaction_ptr_container BMLStaticData::sapc;

//ftHg̒ẽXs[h
double BMLStaticData::mDefaultSpeed =  BML_DEFAULT_BULLET_SPEED;
//e̐
int BMLStaticData::mBulletNum = 0;
//t[
int BMLStaticData::mFrame = 0;


bool BMLStaticData::Init(int bulletnum,double bulletspeed,int queuesize){
	if(0 == bulletnum ) return false;
	//simple container
	bullets.Init (bulletnum,queuesize);
	//action list
	action_list.Init (bulletnum,queuesize);
	//smartaction_ptr̃Rei
	sapc.reserve(bulletnum);

	//action list free queue
	fq.clear();
	//action list push queue
	pq.clear();

	mDefaultSpeed =  bulletspeed;
//e̐
	mBulletNum = 0;
//t[
	mFrame = 0;
	return true;
}


bool  BMLStaticData::End(){
	bullets.End_();
	action_list.End_();
	sapc.clear();
	fq.clear();
	pq.clear();
	
	mDefaultSpeed =  BML_DEFAULT_BULLET_SPEED;
//e̐
	mBulletNum = 0;
//t[
	mFrame = 0;
	return true;
}

void BMLStaticData::ActionBulletInsertProcess(){
	action_handle h;//ef[^p
	sa_ptr_handle ph;//smart_pointer p
	if(pq.empty()) return;
	
	al_push_queue::iterator it = pq.begin();
	for(;;){
		if(action_list.isMax())
		{//łɓȂB
			//܂ł͔̂̂jB
			for(;it != pq.end();it++){
				(*it).first.Delete();
			}
			break;
		}
		for(;it != pq.end();it++){
			ph = sapc.push((*it).first);
			h = action_list.push(&(*it).second,ebmlACTION_BULLET);

			DKUTIL_NOT_ASSERT(ph < -1 || h < -1);
			int aaa = sapc.capacity() + sapc.size();
			DKUTIL_NOT_ASSERT(aaa <= 0);
			DKUTIL_NOT_ASSERT(ph > aaa || \
				h > action_list.max_size());

			if(-1 != ph && -1 != h
				&& ph >= 0 && h >= 0
				)
			{//
				IncBulletNum();
				//݊֘AtȂ񂩃oǑɂȂ肻ȥB
				at_action_ptr(ph)->setHandle(h);
				at_action_bullet(h).action_handle = ph;
			}
			else
			{//s
				if(-1 != ph){//X}[g|C^
					sapc.at(ph).Delete();
				}
				if(-1 !=h){//ë
					action_list.pop(h);
				}
				//dODS("action faild.");

				if(action_list.isMax())
				{//jB
					al_push_queue::iterator e = it;//c̃Ce[^炤B
					e++;
					if(e == pq.end()) break;
					for(;e != pq.end();e++){
						(*e).first.Delete();

						//sapc.at((*e).first).Delete();
						//(*e).Delete();
					}
					//it = pq.end();
					//it --;
					break;//jB
				}
			}//end of check if


		}//end of iterate for
		break;
	}//end of scoped for

	//clear push queue
	pq.clear();

/*
	action_handle h;
	if(pq.empty()) return;
	
	al_push_queue::iterator it = pq.begin();
	
	for(;;){
		if(action_list.isMax()){//łɓȂB
			//܂ł͔̂̂jB
			for(;it != pq.end();it++){
				sapc.at((*it).action_handle).Delete();
			}
			break;
		}
		for(;it != pq.end();it++)
		{
			h = action_list.push(&(*it));//pointer 
			
			if(-1!=h)
			{//
				IncBulletNum();
				at_action(h).setHandle(h);
			}
			else
			{//s
				sapc.at((*it).action_handle).Delete();
				//dODS("action faild.");
				if(action_list.isMax())
				{//jB
					al_push_queue::iterator e = it;
					e++;
					for(;e != pq.end();e++){
						sapc.at((*e).action_handle).Delete();
						//(*e).Delete();
					}
					it = pq.end();
					it --;
					break;//jB
				}
			}
		}//end of iterate for
		break;
	}//end of break for
	pq.clear();
	*/
}


void BMLStaticData::ActionBulletEraseProcess(){
	for(;;){
		if(fq.empty()) break;
		al_free_queue::iterator it = fq.begin();
		for(;it != fq.end();it++){
		
			//X}[g|C^폜
			sapc.at((*it).first).Delete();
			//X}[g|C^p̈|bv
			sapc.pop((*it).first);
			//ef[^|bv
			action_list.pop( (*it).second );
		}
		//NAI
		fq.clear();
		break;
	}
}

void BMLStaticData::ActionBulletRunningProcess()
{
	action_iterator it=BMLStaticData::s_begin_a();
	for(;it != BMLStaticData::s_end_a();it++)
	{
		if(ebmlACTION_BULLET != (*it).flag )
		{//Action Bulletł͖B
			continue;
		}
		smartaction_ptr &rd = BMLStaticData::at_action_ptr((int)(*it).action_handle);
#	ifdef NDEBUG
		if(rd.isNull()){
			dkutil::dODS("ȂX}|NULL");
			continue;
		}
#	else
		if(rd.get()==NULL){
			dkutil::dODS("ȂX}|NULL");
			continue;
		}
#	endif
		if(rd.get()->isEnd()){
			PopActionBullet(it);
		}else{
			rd.get()->run();
		}
	}//end of for
}

void BMLStaticData::PushActionBullet(const smartaction_ptr &x,BML_BULLET_DATA &data){
	al_pq_item item(x,data);
	pq.push_back(item);
	//sa_ptr_handle lh = sapc.push(x);//܂̓X}[g|C^i[
	//if(-1==lh){return -1;}
	//data->action_handle = lh;//i[
	//action_handle h = pq.push(data);//ef[^i[
	//return h;
}	


void BMLStaticData::PopActionBullet(action_iterator it){
	(*it).flag = ebmlKILL_WAIT;//Y҂B
	//oO`FbN
	int h = (*it).action_handle;
	DKUTIL_NOT_ASSERT(h < 0);
	DKUTIL_NOT_ASSERT(h > (int) sapc.capacity() + sapc.size());
	//pointerւ̃nhEef[^ւ̃nh
	al_fq_item item(h,(*it).pos);
	
	fq.push_back(item);//Y҂̗ɂȂ

	DecBulletNum();//fNg
	//PushActionBullet((*it).pos);
}

void BMLStaticData::PopActionBullet(action_handle it){
	BML_BULLET_DATA &rd = action_list.at(it);
	rd.flag = ebmlKILL_WAIT;//Y҂B
	//oN`FbN
	DKUTIL_NOT_ASSERT(rd.action_handle < 0);
	DKUTIL_NOT_ASSERT(rd.action_handle > (int) sapc.capacity() + sapc.size());
	//pointerւ̃nhEef[^ւ̃nh
	al_fq_item item(rd.action_handle,it);
	
	fq.push_back(item);
	DecBulletNum();

}


simple_handle BMLStaticData::PushSimpleBullet(const BML_BULLET_DATA &x){
	int r;	
	r = bullets.push(&x,ebmlSIMPLE_BULLET);

	if(-1!=r){
		IncBulletNum();
	}else{
		//dODS("WHY?");
	}
	return r;
}

void BMLStaticData::PopSimpleBullet(simple_iterator it){
	if(bullets.max_size() <= (*it).pos){
		std::string s = "pos";
		s += dkutil::to_string((*it).pos);
		DK_WARNING(s.c_str());
	}
	//if((*it).isUse()){
	(*it).flag = false;//Ôߓ|B
	bullets.pop((*it).pos);
	DecBulletNum();
	//}
}



void BulletMLManager::Move() {

	{
		simple_iterator it=BMLStaticData::s_begin_s();
		for(int i=0;it != BMLStaticData::s_end_s(); it++,i++) {
			if(ebmlSIMPLE_BULLET != (*it).flag)
			{//SIMPLE Bulletł͖B
				continue;
			}
	
			//move simple bullets
			(*it).x += (*it).accelx * BMLStaticData::GetBulletSpeed();
			(*it).y += (*it).accely * BMLStaticData::GetBulletSpeed();
		}
		
	}
	{
		action_iterator it=BMLStaticData::s_begin_a();
		for(;it != BMLStaticData::s_end_a();it++)
		{
			if(ebmlACTION_BULLET != (*it).flag )
			{//Action Bulletł͖B
				continue;
			}
			smartaction_ptr &rd = BMLStaticData::at_action_ptr((int)(*it).action_handle);
			if(rd.get()==NULL){
				dkutil::dODS("ȂX}|NULL");
				continue;
			}
			rd.get()->Move();
		}
	}

	//t[AbvB
	BMLStaticData::IncFrame();
	
}

void BulletMLManager::Update(){
	//œK
	BMLStaticData::arrangement_memory();

}


BulletMLManager::xml_handle BulletMLManager::LoadBMLFile(const char *filename)
{
	if(false==dkutil::FileExist(filename)){
		throw std::runtime_error("݂Ȃt@CɓȁI");
	}

	DXEX_XMLPARSER_PTR p = DXEX_XMLPARSER_PTR(
		new BULLETML_PARSER("none"));

	try {
		p->parse_from_file(filename);
		//̏\ԂH
		p->build();
	}catch (BulletMLError be) {
		dkutil::dODS(be.what());
		throw;//܂OOGGG
	}
	//ReiɂԂ
	return mXMLC.push(p);
	
}



BulletMLManager::xml_handle BulletMLManager::LoadBML(const char *memory_image_str)
{
	if(!memory_image_str){
		throw std::runtime_error("NULLɓȁI");
	}
	DXEX_XMLPARSER_PTR p = DXEX_XMLPARSER_PTR(
		new BULLETML_PARSER(memory_image_str));
	try {
		p->parse();
		//̏\ԂH
		p->build();
	}catch (BulletMLError be) {
		dkutil::dODS(be.what());
		throw;//܂OOGGG
	}
	//ReiɂԂ
	return mXMLC.push(p);
}

bool BulletMLManager::UnloadBML(BulletMLManager::xml_handle h,bool isCheck){
	if(isCheck){
		typedef PARSED_XML_CONTAINER::DEQUE_TYPE QTYPE;
		const QTYPE &q = mXMLC.get_deque();
		QTYPE::const_iterator it = q.begin();
		for(;it != q.end();it++){
			if((*it)==h)
			{//łɍ폜ς݂B
				return false;
			}
		}
	}
	//{ɃX}[g|C^͏Ă̂낤H
	mXMLC.pop(h);
	return true;
}

}//end of bml namespace